# netsim

An element that simulates network jitter, packet loss and packet duplication

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──netsim

## Factory details

Authors: – Philippe Kalaf <philippe.kalaf>, Havard Graff <havard></havard></philippe.kalaf>

Classification: – `Filter/Network`

Rank – marginal

Plugin – netsim

Package – GStreamer Bad Plug-ins

## Pad Templates

### `sink`

    ANY

Presence – always

Direction – sink

Object type – GstPad

### `src`

    ANY

Presence – always

Direction – src

Object type – GstPad

## Properties

### allow-reordering

    “allow-reordering” gboolean

When delaying packets, are they allowed to be reordered or not. By default this is enabled, but in the real world packet reordering is fairly uncommon, yet the delay functions will always introduce reordering if delay > packet-spacing, This property allows switching that off.

Flags : Read / Write / Construct

Default value : true

Since : 1.14

### delay-distribution

    “delay-distribution” GstNetSimDistribution *

Distribution for the amount of delay.

Flags : Read / Write / Construct

Default value : uniform (0)

Since : 1.14

### delay-probability

    “delay-probability” gfloat

The Probability a buffer is delayed

Flags : Read / Write / Construct

Default value : 0

### drop-packets

    “drop-packets” guint

Drop the next n packets

Flags : Read / Write / Construct

Default value : 0

### drop-probability

    “drop-probability” gfloat

The Probability a buffer is dropped

Flags : Read / Write / Construct

Default value : 0

### duplicate-probability

    “duplicate-probability” gfloat

The Probability a buffer is duplicated

Flags : Read / Write / Construct

Default value : 0

### max-bucket-size

    “max-bucket-size” gint

The size of the token bucket, related to burstiness resilience.

Flags : Read / Write / Construct

Default value : -1

Since : 1.14

### max-delay

    “max-delay” gint

The maximum delay (inclusive) in ms to apply to buffers

Flags : Read / Write / Construct

Default value : 400

### max-kbps

    “max-kbps” gint

The maximum number of kilobits to let through per second. Setting this property to a positive value enables network congestion simulation using a token bucket algorithm. Also see the "max-bucket-size" property,

Flags : Read / Write / Construct

Default value : -1

Since : 1.14

### min-delay

    “min-delay” gint

The minimum delay in ms to apply to buffers

Flags : Read / Write / Construct

Default value : 200

## Named constants

### GstNetSimDistribution

#### Members

`uniform` (0) – uniform
`normal` (1) – normal
`gamma` (2) – gamma

The results of the search are